package rejtveny;

import java.util.ArrayList;

public class Tabla {

	private int[][] tabla = new int[11][11];

	private String nev;
	public String getNev() {
		return nev;
	}

	
	public Tabla(String _nev, String[] _sor) {
		nev = _nev;
		for (int i = 1; i <= _sor.length; i++) {
			String[] string = _sor[i - 1].split(" ");
			for (int j = 1; j <= string.length; j++) {
				tabla[i][j] = Integer.parseInt(string[j - 1]);
			}
		}
	}
	

	private boolean JoHely(int sor, int oszlop) {
		boolean jo = true;
		int i = -1;
		while (jo && i < 2) {
			int j = -1;
			while (jo && j < 2) {
				if (!(i == 0 && j == 0) && sor + i > 0
						&& sor + i < 11 && oszlop + j > 0
						&& oszlop + j < 11
						&& tabla[sor + i][oszlop + j] != 0) {
					jo = false;
				}
				j++;
			}
			i++;
		}
		return jo;
	}
	
	
	public ArrayList<Hely> Torony() {
		ArrayList<Hely> lista = new ArrayList<Hely>();
		for (int i = 1; i < 11; i++) {
			for (int j = 1; j < 11; j++) {
				if (tabla[i][j] > 0 && tabla[i][j] < 10) {
					Hely torony = new Hely(i, j, tabla[i][j], JoHely(i, j));
					lista.add(torony);
				}
			}
		}
		return lista;
	}

	
	public ArrayList<Hely> Hajo() {
		ArrayList<Hely> lista = new ArrayList<Hely>();
		for (int i = 1; i < 11; i++) {
			for (int j = 1; j < 11; j++) {
				if (tabla[i][j] == 11) {
					Hely hajo = new Hely(i, j, tabla[i][j], JoHely(i, j));
					lista.add(hajo);
				}
			}
		}
		return lista;
	}

	
	public int JoHelyenDb(){
		int db = 0;
		for (Hely hajo : Hajo()) {
			db += hajo.getJo()?1:0;
		}
		return db;
	}

	
	public boolean MindJo() {
		int db = 0;
		for (Hely t : Torony()) {
			int hajoDb = 0;
			for (int i = 1; i < 11; i++) {
				if (tabla[i][t.getOszlop()] == 11) {
					hajoDb++;
				}
				if (tabla[t.getSor()][i] == 11) {
					hajoDb++;
				}
			}
			if (hajoDb == t.getErtek()) {
				db++;
			}
		}
		return (db == Torony().size());
	}
}
